#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "jacob.h"

void main(void)
{
  float **Nmatrix, **eigmatrix, *eigenvec, mineig;
  int nrot, minind, i, j;

  long n = 3;

  // allocate matrices/vector 
  // Note that numerical recipes matrix indices start at 1, not 0 !!!!!!!!!!!!

  // allocate a float matrix with subscript range m[1..n][1..n] 
  Nmatrix = matrix(1,n,1,n);
  eigmatrix = matrix(1,n,1,n);
  // allocate a float vector with subscript range v[1..n]
  eigenvec = vector(1,n);

  // fill up the elements of the matrix however you like, 
  // just make sure it is symmetric: Nmatrix[a][b] = Nmatrix[b][a] for all a, b
  
  for ( i = 1; i <= n; i++ )
  {
	for (j = 1; j<=i; j++)
	{
	  Nmatrix[i][j] = (float)rand()/(float)RAND_MAX;
	}		
  }
  
  for ( i = 1; i<=n; i++)
  {
	for (j=i+1;j<=n;j++)
	{
		Nmatrix[i][j] = Nmatrix[j][i];
	}
  }

  // run jacobi method to do eigen-decomposition 
  jacobi(Nmatrix, n, eigenvec, eigmatrix, &nrot);

  // find smallest eigenvalue 
  mineig = eigenvec[1];
  minind = 1;
  for (i=2; i <= n; i++) {
    if (eigenvec[i] < mineig) {
      mineig = eigenvec[i];
      minind = i;
    }
  }

  // eigenvector associated with smallest eigenvalue put in x,y,z 
  printf("eigenvector associated with smallest eigenvalue:\n");
  for (i=1;i<=n;i++)
  {
	  printf("%f\n",eigmatrix[i][minind]);
  }
  printf("\n");

  // free up allocated space 
  free_matrix(Nmatrix,1,n,1,n);
  free_matrix(eigmatrix,1,n,1,n);
  free_vector(eigenvec,1,n);
}
